#pragma once

#include "Enum.h"

class WorkGroupController;

class WorkGroupActorEvent : public IGTWASActorEvent, IGTMessengerActorEvent
{
public:
	WorkGroupActorEvent(WorkGroupController* pController);
	virtual ~WorkGroupActorEvent(void);

	typedef struct  
	{
		MemberListAction action;
		int nGroupID;
	} MemberListData;

	void AddNameSearchTrid(trid_t trid, MemberSearchAction action)
	{
		m_nameSearchListTrid.insert(make_pair(trid, action));
	}

	void AddMemberGroupListTrid(trid_t trid, MemberGroupListAction action)
	{
		m_memberGroupListTrid.insert(make_pair(trid, action));
	}

	void AddMemberListTrid(trid_t trid, MemberListData data)
	{
		m_memberListTrid.insert(make_pair(trid, data));
	}

	void SetBuddyActionTrid(trid_t trid)
	{
		m_buddyActionTrid = trid;
	}
	trid_t GetBuddyActionTrid()	{ return m_buddyActionTrid; }

	virtual bool OnGTWASActor_ResponseNameSearchList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_SEARCH_MEMBER_DATA_LIST &list);
	virtual bool OnGTWASActor_ResponseMemberGroupList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_ORG_GROUP_DATA_LIST &list);
	virtual bool OnGTWASActor_ResponseMemberList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list);
	virtual bool OnGTMessengerActor_UpdateNotBuddyUserStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID, int nUserStatus, LPCWSTR strNick, int nIPTStatus, int nFlag);
	virtual bool OnGTMessengerActor_ResponseBuddyAction(IGTMessengerActor *pActor, const GT_BUDDY_RESULT_DATA& sData);

private:
	void MemberGroupListResponseAction(MemberGroupListAction action, const GT_ORG_GROUP_DATA_LIST &list);
	void MemberListResponseAction(const MemberListData& data, const NE_MEMBER_DATA_LIST &list );
	void MemberSearchResponseAction( MemberSearchAction action, const NE_SEARCH_MEMBER_DATA_LIST &list );

	WorkGroupController* m_pController;

	std::map<trid_t, MemberSearchAction> m_nameSearchListTrid;
	std::map<trid_t, MemberGroupListAction> m_memberGroupListTrid;
	std::map<trid_t, MemberListData> m_memberListTrid;
	trid_t	m_buddyActionTrid;
};
